// --------------------------------------------------------------------------
// main.pas
//
// Copyright 1999, 2004  Antony Pranata
// http://www.antonypranata.com
//
// TTrayIcon example (see TrayIcon.pas).
// --------------------------------------------------------------------------

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TrayIcon, ExtCtrls, Menus, ShellApi;

type
  TFormMain = class(TForm)
    ButtonHideWindow: TButton;
    TrayIcon: TTrayIcon;
    PopupMenu: TPopupMenu;
    ShowWindowMenu: TMenuItem;
    N1Menu: TMenuItem;
    AboutMenu: TMenuItem;
    N2Menu: TMenuItem;
    ExitMenu: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    EditIcon: TEdit;
    EditTip: TEdit;
    ButtonBrowse: TButton;
    OpenDialog: TOpenDialog;
    ButtonUpdate: TButton;
    ButtonShowIcon: TButton;
    ButtonHideIcon: TButton;
    LabelURL: TLabel;
    Label6: TLabel;
    Label3: TLabel;
    procedure ButtonHideWindowClick(Sender: TObject);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure ExitMenuClick(Sender: TObject);
    procedure AboutMenuClick(Sender: TObject);
    procedure TrayIconDblClick(Sender: TObject);
    procedure LabelURLClick(Sender: TObject);
    procedure ButtonUpdateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonShowIconClick(Sender: TObject);
    procedure ButtonHideIconClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  end;

var
  FormMain: TFormMain;

implementation

uses about;

{$R *.DFM}

procedure TFormMain.ButtonHideWindowClick(Sender: TObject);
begin
  // Hides this window.
  Hide;
  if (ButtonHideWindow.Enabled) then
    ButtonShowIconClick(Sender);
end;

procedure TFormMain.ButtonBrowseClick(Sender: TObject);
begin
  // Gets the file names
  if (OpenDialog.Execute) then
    EditIcon.Text := OpenDialog.FileName;
end;

procedure TFormMain.ExitMenuClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFormMain.AboutMenuClick(Sender: TObject);
begin
  FormAbout.ShowModal;
  ShowWindow(GetWindow (Handle, GW_OWNER), SW_HIDE);
end;

procedure TFormMain.TrayIconDblClick(Sender: TObject);
begin
  // Shows the window.
  Show;
end;

procedure TFormMain.LabelURLClick(Sender: TObject);
begin
  ShellExecute(
    0, nil, 'http://www.antonypranata.com',
    nil, nil, SW_SHOWNORMAL);
end;

procedure TFormMain.ButtonUpdateClick(Sender: TObject);
begin
  // Updates the tray icon.
  TrayIcon.Tip  := EditTip.Text;
  if (EditIcon.Text <> '') then
    TrayIcon.Icon.LoadFromFile(EditIcon.Text);
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  // Shows the icon.
  TrayIcon.Tip  := EditTip.Text;
  TrayIcon.Show;
end;

procedure TFormMain.ButtonShowIconClick(Sender: TObject);
begin
  TrayIcon.Show;
  ButtonShowIcon.Enabled := false;
  ButtonHideIcon.Enabled := true;
end;

procedure TFormMain.ButtonHideIconClick(Sender: TObject);
begin
  TrayIcon.Hide;
  ButtonShowIcon.Enabled := true;
  ButtonHideIcon.Enabled := false;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  // Hides the parent window from task bar
  // If the parent window is not hidden, it will be shown on the task bar.
  ShowWindow (GetWindow (Handle, GW_OWNER), SW_HIDE);
  ShowWindow (Handle, SW_HIDE);
end;

end.
